--***********************************************************************************************
--
--  Script skeleton was:   Arch&Design AO/RC Option and conversion tool from PF Breton, Zap Andersson
--
--	Modified: May 23 2013
--	Author:   Jonathan Baecker (jb_alvardo), www.pixelcrusher.de
--
--***********************************************************************************************

(
	----------------------------------------------------
	--  Set Parameter Function
	----------------------------------------------------
	fn setMtlParam mtl param over under val =
	(	
		case classof mtl of
		( 
			--------------------------------------------------
			--mrArchMtl
			--------------------------------------------------
			mrArchMaterial:
			(	
				if ( classof mtl ) == mrArchMaterial do 
				(				
				if (mtl.refl_gloss < 1.0 AND mtl.refl_samples > over AND mtl.refl_samples < under AND mtl.refl_hlonly == off) do (
					SetProperty mtl param val
					)
				if (mtl.refr_weight > 0.0 AND mtl.refr_gloss < 1.0 AND mtl.refr_samples > over AND mtl.refr_samples < under) do (
					SetProperty mtl param val
					)	
				)	
			)
		
			--------------------------------------------------
			-- Multimaterials
			--------------------------------------------------
			MultiMaterial: 
			(
				local u
				orgMtl = mtl
				
				NumTemp = mtl.numsubs
				for u = 1 to NumTemp do 
				(
					if ( classof mtl[u] ) == mrArchMaterial do 
				(		
					if (mtl[u].refl_gloss < 1.0 AND mtl[u].refl_samples > over AND mtl[u].refl_samples < under AND mtl[u].refl_hlonly == off) do (
						SetProperty mtl[u] param val
						)
					if (mtl[u].refr_weight > 0.0 AND mtl[u].refr_gloss < 1.0 AND mtl[u].refr_samples > over AND mtl[u].refr_samples < under) do (
						SetProperty mtl[u] param val
						)	
					)
				)						
			)
		)
	)
	
	fn setMtlParamSimple mtl param val =
	(	
		case classof mtl of
		( 
			--------------------------------------------------
			--mrArchMtl
			--------------------------------------------------
			mrArchMaterial:
			(	
				if ( classof mtl ) == mrArchMaterial do 
				(				
					SetProperty mtl param val
					)
				)
		
			--------------------------------------------------
			-- Multimaterials
			--------------------------------------------------
			MultiMaterial: 
			(
				local u
				orgMtl = mtl
				
				NumTemp = mtl.numsubs
				for u = 1 to NumTemp do 
				(
					if ( classof mtl[u] ) == mrArchMaterial do 
				(		
					SetProperty mtl[u] param val
					)
				)					
			)
		)
	)

	----------------------------------------------------
	--  Main rollout
	----------------------------------------------------		
	rollout mrArchMtlUtilities "Arch&Design Tuning" width:386
	(
		local theProgramName 	= "Arch&Design Tuning"
		local theUndoName		= "Arch&DesignTuning"
		local orgSceneMaterials = undefined
		local numOfMatInScene   = undefined
	
		GroupBox GRP_AffectMaterials "Affect Materials..." pos:[6,6] width:184 height:62
			radiobuttons rdoMaterialsToUse "" pos:[53,29] width:130 height:32 labels:#("...in complete scene", "...in material editor only") columns:1

		GroupBox GRP_Progress "Progress" pos:[196,6] width:184 height:62
			label lblProgress "" pos:[203,29] width:170 height:14
			progressBar prgProgress "" pos:[203,49] width:170 height:12 color:[0,200,0]
		
		GroupBox GRP_AffectGlossiness "Affect Glossiness" pos:[6,86] width:374 height:62
			button btnRflSample "Reflections Glossiness Sample" pos:[13,105] width:150 height:16
			spinner spnRflOverSample "Over:" pos:[194,105] width:40 height:16 range:[0,512,4]  type:#integer
			spinner spnRflUnderSample "Under:" pos:[268,105] width:40 height:16 range:[0,512,16]  type:#integer
			spinner spnRflSample "To:" pos:[332,105] width:40 height:16 range:[0,512,32] type:#integer

			button btnRfrSample "Refractions Glossiness Sample" pos:[13,125] width:150 height:16
			spinner spnRfrOverSample "Over:" pos:[194,125] width:40 height:16 range:[0,512,4]  type:#integer
			spinner spnRfrUnderSample "Under:" pos:[268,125] width:40 height:16 range:[0,512,16]  type:#integer
			spinner spnRfrSample "To:" pos:[332,125] width:40 height:16 range:[0,512,32] type:#integer
			
		GroupBox GRP_Fast_interpolate "Fast (interpolate)" pos:[6,154] width:374 height:32
			checkbox chkFastRfl "Interpolate Reflection" pos:[13,168] width:130 height:15
			checkbox chkFastRfr "Interpolate Refraction" pos:[203,168] width:130 height:15
			
		GroupBox GRP_AmbientOcclusion "Ambient occlusion" pos:[6,190] width:184 height:94
			button btnAoOn "Turn ON" pos:[13,208] width:85 height:21
			button btnAoOff "Turn OFF" pos:[100,208] width:85 height:21
			button btnAoSample "Sample" pos:[13,232] width:44 height:16
			spinner spnAoSample "" pos:[58,232] width:40 height:16 range:[0,512,16] type:#integer
		
			button btnAoExAoOn "ExOn" pos:[100,232] width:39 height:16
			button btnAoExAoOff "ExOff" pos:[146,232] width:39 height:16		
		
			button btnAoForceRadius "Force radius" pos:[13,260] width:70 height:16
			spinner spnAoRadius "" pos:[89,260] width:97 height:16 range:[0,65535,10] type:#worldunits
	
		GroupBox GRP_RoundCorners "Round corners" pos:[196,190] width:184 height:94
			button btnRcOn "Turn ON" pos:[203,208] width:170 height:21
			button btnRcOff "Turn OFF" pos:[203,232] width:170 height:21
			button btnRcForceRadius "Force radius" pos:[203,260] width:70 height:16
			spinner spnRcRadius "" pos:[279,260] width:94 height:16 range:[0,65536,25] type:#worldunits	
			
		GroupBox GRP_AdvancedOptions "Advanced Rendering Options" pos:[6,296] width:374 height:38
			checkbox chkBackFace "Back Face Culling" pos:[13,312] width:130 height:15
			checkbox chkTransAlpha "Transparency propagates Alpha" pos:[203,312] width:173 height:15	

		fn doMaterialParamSet param over under val = 
		(
			theUndoContextName = ( theUndoName + " - set parameter" )
			
			undo theUndoContextName on
			(	
				numOfMatInScene = orgSceneMaterials.count
				if (numOfMatInScene == 0) do
				(
					MessageBox "There are no materials in your current selection!" title:theProgramName 
				)				
				
				for i = 1 to numOfMatInScene do 
				(
					lblProgress.caption = ("Setting: " + orgSceneMaterials[i].name)
					setMtlParam orgSceneMaterials[i] param over under val
					prgProgress.value = 100.000 / numOfMatInScene * i
				)
				lblProgress.caption = ("Done")
				prgProgress.value = 100				
			)
		)
		
		fn doMaterialParamSetSimple param val = 
		(
			theUndoContextName = ( theUndoName + " - set parameter" )
			
			undo theUndoContextName on
			(	
				numOfMatInScene = orgSceneMaterials.count
				if (numOfMatInScene == 0) do
				(
					MessageBox "There are no materials in your current selection!" title:theProgramName 
				)				
				
				for i = 1 to numOfMatInScene do 
				(
					lblProgress.caption = ("Setting: " + orgSceneMaterials[i].name)
					setMtlParamSimple orgSceneMaterials[i] param val
					prgProgress.value = 100.000 / numOfMatInScene * i
				)
				lblProgress.caption = ("Done")
				prgProgress.value = 100				
			)
		)

		--------------------------------------------------
		on mrArchMtlUtilities open do 
		(
			case rdoMaterialsToUse.state of
			(
				1: orgSceneMaterials = sceneMaterials
				2: orgSceneMaterials = meditMaterials
			)

		)
		--------------------------------------------------
		on rdoMaterialsToUse changed state do
		(
			case rdoMaterialsToUse.state of
			(
				1: orgSceneMaterials = sceneMaterials
				2: orgSceneMaterials = meditMaterials
			)
		)		
		on btnRflSample pressed do ( doMaterialParamSet #refl_samples spnRflOverSample.value spnRflUnderSample.value spnRflSample.value )			
		on btnRfrSample pressed do ( doMaterialParamSet #refr_samples spnRfrOverSample.value spnRfrUnderSample.value spnRfrSample.value )		
		
		--------------------------------------------------
		
		on chkFastRfl changed state do ( doMaterialParamSetSimple #refl_interp state )
		on chkFastRfr changed state do ( doMaterialParamSetSimple #refr_interp state )
		
		on btnAoOff pressed do ( doMaterialParamSetSimple #opts_ao_on false )
		on btnAoOn pressed do ( doMaterialParamSetSimple #opts_ao_on true )
		on btnAoForceRadius pressed do ( doMaterialParamSetSimple #opts_ao_distance spnAoRadius.value )
		on btnAoSample pressed do ( doMaterialParamSetSimple #opts_ao_samples spnAoSample.value )
		
		on btnAoExAoOn pressed do ( doMaterialParamSetSimple #opts_ao_exact on )
		on btnAoExAoOff pressed do ( doMaterialParamSetSimple #opts_ao_exact off )
		
		--------------------------------------------------
		on btnRcOff pressed do ( doMaterialParamSetSimple #opts_round_corners_on false )
		on btnRcOn pressed do ( doMaterialParamSetSimple #opts_round_corners_on true )
		on btnRcForceRadius pressed do ( doMaterialParamSetSimple #opts_round_corners_radius spnRcRadius.value )
		
		on chkBackFace changed state do ( doMaterialParamSetSimple #opts_backface_cull state )
		on chkTransAlpha changed state do ( doMaterialParamSetSimple #opts_propagate_alpha state )
	)		
	------------------------------------------------------
	try ( destroyDialog mrArchMtlUtilities )
	catch (	MessageBox "Dialog not found!" )
	
	createDialog mrArchMtlUtilities style:#(#style_toolwindow, #style_border, #style_sysmenu)
)
